## ecbuild 3.7.1

=== CMakeLists.txt ===
# (C) Copyright 2011- ECMWF.
#
# This software is licensed under the terms of the Apache Licence Version 2.0
# which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
# In applying this licence, ECMWF does not waive the privileges and immunities
# granted to it by virtue of its status as an intergovernmental organisation
# nor does it submit to any jurisdiction.

############################################################################################
# cmake options:
#
#       -DCMAKE_INSTALL_PREFIX=/path/to/install

cmake_minimum_required( VERSION 3.11.0 FATAL_ERROR )

set( CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake" ${CMAKE_MODULE_PATH} )


include( ecbuild )
project( ecbuild LANGUAGES C )

###############################################################################
# local project

configure_file( cmake/ecbuild_version.h.in ${CMAKE_BINARY_DIR}/ecbuild_version.h  )

# contents

ecbuild_add_resources(  TARGET ${PROJECT_NAME}_description_files
                        SOURCES_PACK
                            README.rst
                            INSTALL.rst
                            AUTHORS
                            NOTICE
                            LICENSE
                            COPYING
)

add_subdirectory( bin )
add_subdirectory( share )
add_subdirectory( cmake )
add_subdirectory( doc )

add_subdirectory( regressions )
add_subdirectory( tests )

install( DIRECTORY cmake DESTINATION ${INSTALL_DATA_DIR} PATTERN "CMakeLists.txt" EXCLUDE )

if( NOT CMAKE_SOURCE_DIR STREQUAL PROJECT_SOURCE_DIR AND ECBUILD_2_COMPAT )
    # Required for ecbuild-2 packages when ecbuild is added using `add_subdirectory( ecbuild ) [See ECBUILD-460].

    # When adding ecbuild to your project using `add_subdirectory( ecbuild )`, and subsequently add a ecbuild-2 project
    # which by definition is not using `find_package( ecbuild )`, then the ecbuild-macros dir must be added to
    # the CMAKE_MODULE_PATH.
    # The `find_package( ecbuild ... )` works for the ecbuild-3-ported packages, as `ecbuild_DIR` gets defined in
    # `ecbuild_declare_project(ecbuild...)` of ecbuild during `add_subdirectory( ecbuild )`

    set( CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} PARENT_SCOPE )
endif()

############################################################################################
# finalize

ecbuild_install_project( NAME ${PROJECT_NAME} )

ecbuild_print_summary()

=== examples/cpp-bundle-nested/CMakeLists.txt ===
# (C) Copyright 2011- ECMWF.
#
# This software is licensed under the terms of the Apache Licence Version 2.0
# which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
# In applying this licence, ECMWF does not waive the privileges and immunities
# granted to it by virtue of its status as an intergovernmental organisation
# nor does it submit to any jurisdiction.

cmake_minimum_required( VERSION 3.11 FATAL_ERROR )

find_package( ecbuild REQUIRED )
project( cpp_bundle_nested VERSION 0.10.0 LANGUAGES C CXX )

ecbuild_bundle_initialize()

ecbuild_bundle( PROJECT bar )
ecbuild_bundle( PROJECT baz )

ecbuild_bundle_finalize()

=== examples/override-compile-flags/foo/CMakeLists.txt ===
# (C) Copyright 2011- ECMWF.
#
# This software is licensed under the terms of the Apache Licence Version 2.0
# which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
# In applying this licence, ECMWF does not waive the privileges and immunities
# granted to it by virtue of its status as an intergovernmental organisation
# nor does it submit to any jurisdiction.

cmake_minimum_required( VERSION 3.11 FATAL_ERROR )

find_package( ecbuild REQUIRED )
project( foo VERSION 0.1 LANGUAGES Fortran C )

ecbuild_enable_fortran ( REQUIRED MODULE_DIRECTORY ${CMAKE_BINARY_DIR}/module )

ecbuild_find_package( NAME bar REQUIRED )

### targets

ecbuild_add_library( TARGET       foo
                     SOURCES      foo.c
                                  foo.f90
                                  foo_contiguous.f90
                                  foo_intolerant.f90
                                  foo_ivybridge.f90
                                  foo_no_debug_symbols.f90
                     PRIVATE_LIBS bar )

ecbuild_install_project( NAME ${PROJECT_NAME} )

ecbuild_print_summary()

=== regressions/ECBUILD_495/proj/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.12 FATAL_ERROR)

find_package(ecbuild 3.4 REQUIRED)

project(foo VERSION 0.1 LANGUAGES NONE)

list(APPEND CMAKE_MODULE_PATH ${CMAKE_CURRENT_LIST_DIR/cmake})

ecbuild_find_package(Bar REQUIRED)

=== regressions/ECBUILD_511/projectC/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.12 FATAL_ERROR)

find_package(ecbuild 3.4 REQUIRED)

project(projectC VERSION 0.1.0 LANGUAGES C)

find_package(projectB REQUIRED)

ecbuild_add_executable(
  TARGET main
  SOURCES main.c
  LIBS projectB)

ecbuild_install_project(NAME ${PROJECT_NAME})

=== tests/ecbuild_find_package/projectC/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.11 FATAL_ERROR)

find_package( ecbuild REQUIRED )
project( projectC VERSION 0.1.0 LANGUAGES CXX )

ecbuild_find_package( NAME projectB REQUIRED )

if( NOT projectB_MODULE )
  ecbuild_critical( "projectB must be found via contained cmake/FindprojectB.cmake")
endif()

ecbuild_add_library( TARGET projectC SOURCES libraryC.cc libraryC.h INSTALL_HEADERS LISTED PRIVATE_LIBS projectB )

ecbuild_add_executable( TARGET main-C SOURCES main.cc LIBS projectC )

ecbuild_install_project( NAME ${PROJECT_NAME} )

=== tests/project_import/projectB/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.12 FATAL_ERROR)

find_package(ecbuild 3.4 REQUIRED)

project(projectB VERSION 0.0 LANGUAGES C)

ecbuild_add_library(TARGET libB SOURCES libB.c)

ecbuild_install_project(NAME ${PROJECT_NAME})

=== tests/project_import/projectC/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.12 FATAL_ERROR)

find_package(ecbuild 3.4 REQUIRED)

project(projectC VERSION 0.1 LANGUAGES NONE)

find_package(projectA REQUIRED)
find_package(projectB REQUIRED)

set(EXP_projectA_FOO foo)
set(EXP_projectA_BAR bar)
set(EXP_projectB_FOO spam)
set(EXP_projectB_BAR eggs)

foreach(var projectA_FOO projectA_BAR projectB_FOO projectB_BAR)
  if(NOT DEFINED ${var})
    message(FATAL_ERROR "${var} is not defined")
  elseif(NOT ${var} STREQUAL EXP_${var})
    message(FATAL_ERROR "${var}: expected ${EXP_${var}}, got ${${var}}")
  else()
    message( "${var} = ${${var}} as expected")
  endif()
endforeach()

=== regressions/ECBUILD_407/mybundle/myexe/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.6 FATAL_ERROR)

project( myexe VERSION 0.1.0 LANGUAGES NONE )

include( ecbuild_system NO_POLICY_SCOPE )

ecbuild_requires_macro_version( 2.9.5 )
ecbuild_declare_project()

ecbuild_find_package( NAME mylib REQUIRED )

if( NOT DEFINED mylib_FOO )
  message( FATAL_ERROR "mylib_FOO is not defined" )
endif()

ecbuild_install_project( NAME ${PROJECT_NAME} )

=== debian/changelog ===
ecbuild (3.7.1-1) unstable; urgency=medium

  * New upstream release

 -- Alastair McKinstry <mckinstry@debian.org>  Wed, 25 Jan 2023 09:55:18 +0000

ecbuild (3.6.5-2) UNRELEASED; urgency=medium

  * Trim trailing whitespace.
  * Use versioned copyright format URI.
  * Set upstream metadata fields: Repository-Browse.
  * Fix broken Vcs URL.
  * Update standards version to 4.6.1, no changes needed.

 -- Debian Janitor <janitor@jelmer.uk>  Fri, 14 Oct 2022 05:04:42 -0000

=== debian/control ===
Source: ecbuild
Section: science
Priority: optional
Maintainer: Alastair McKinstry <mckinstry@debian.org>
Build-Depends: debhelper-compat (= 13),
  dh-buildinfo,
  cmake
Standards-Version: 4.6.1
Homepage: https://confluence.ecmwf.int/spaces/viewspace.action?key=ecbuild
Vcs-Browser: https://salsa.debian.org:/science-team/ecbuild.git
Vcs-Git: https://salsa.debian.org/science-team/ecbuild.git -b debian/latest

Package: ecbuild
Section: libs
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends},
 cmake,
 chrpath,
 dh-buildinfo
Enhances: debhelper
Provides: dh-sequence-ecbuild
Description: Build system for ECMWF software
 This is a toolkit from ECMWF extend CMAKE with macros used at ECMWF.
 .
 ECMWF is the European Centre for Medium-Range Weather Forecasts.

## ecbuild 3.7.2

=== debian/changelog ===
ecbuild (3.7.2-1) experimental; urgency=medium

  * New upstream release
  * Standards-VersIon: 4.6.2

 -- Alastair McKinstry <mckinstry@debian.org>  Wed, 29 Mar 2023 17:27:03 +0100

## ecbuild 3.8.0

=== debian/changelog ===
ecbuild (3.8.0-1) unstable; urgency=medium

  * New upstream release

 -- Alastair McKinstry <mckinstry@debian.org>  Sun, 02 Jul 2023 10:00:19 +0100

ecbuild (3.7.2-2) unstable; urgency=medium

  * Push to unstable

 -- Alastair McKinstry <mckinstry@debian.org>  Sun, 11 Jun 2023 10:45:56 +0100

## ecbuild 3.8.2

=== examples/config-bundle/CMakeLists.txt ===
# (C) Copyright 2011- ECMWF.
#
# This software is licensed under the terms of the Apache Licence Version 2.0
# which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
# In applying this licence, ECMWF does not waive the privileges and immunities
# granted to it by virtue of its status as an intergovernmental organisation
# nor does it submit to any jurisdiction.

cmake_minimum_required( VERSION 3.11 FATAL_ERROR )

find_package(ecbuild REQUIRED)
project( config_bundle VERSION 0.1 LANGUAGES C )

ecbuild_bundle_initialize()

# Use command "make update" to update branches to latest develop version
ecbuild_bundle( PROJECT subproj1 )
ecbuild_bundle( PROJECT subproj2 )

# Finalize
ecbuild_bundle_finalize()

=== examples/cxx11/CMakeLists.txt ===
# (C) Copyright 2011- ECMWF.
#
# This software is licensed under the terms of the Apache Licence Version 2.0
# which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
# In applying this licence, ECMWF does not waive the privileges and immunities
# granted to it by virtue of its status as an intergovernmental organisation
# nor does it submit to any jurisdiction.

cmake_minimum_required( VERSION 3.11 FATAL_ERROR )

find_package(ecbuild REQUIRED)
project( cxx11 VERSION 0.0.1 LANGUAGES CXX )

### definitions

set(CMAKE_CXX_STANDARD 11)

### targets

ecbuild_add_executable( TARGET compute
                        SOURCES compute.cc )

### finalize project

ecbuild_install_project( NAME ${PROJECT_NAME} )

ecbuild_print_summary()

=== examples/override-compile-flags/bar/CMakeLists.txt ===
# (C) Copyright 2011- ECMWF.
#
# This software is licensed under the terms of the Apache Licence Version 2.0
# which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
# In applying this licence, ECMWF does not waive the privileges and immunities
# granted to it by virtue of its status as an intergovernmental organisation
# nor does it submit to any jurisdiction.

cmake_minimum_required( VERSION 3.11 FATAL_ERROR )

find_package( ecbuild REQUIRED )
project( bar VERSION 0.2 LANGUAGES C )

### targets

ecbuild_add_library( TARGET bar SOURCES bar.c )

ecbuild_install_project( NAME ${PROJECT_NAME} )

ecbuild_print_summary()

=== regressions/ECBUILD_511/bundleAB/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.12 FATAL_ERROR)

find_package(ecbuild 3.4 REQUIRED)

project(bundleAB VERSION 0.1.0 LANGUAGES C)

ecbuild_bundle(PROJECT projectA)
ecbuild_bundle(PROJECT projectB)

ecbuild_install_project(NAME ${PROJECT_NAME})

=== tests/bundle_override_features/bundle/CMakeLists.txt ===
cmake_minimum_required( VERSION 3.11 FATAL_ERROR )

find_package( ecbuild REQUIRED )

set( ENABLE_TESTS ON CACHE BOOL "" )
set( PROJECT_A_ENABLE_TESTS OFF CACHE BOOL "" )

set( PROJECT_B_ENABLE_X OFF CACHE BOOL "" )

project( bundle VERSION 0.0.0 LANGUAGES C )

add_subdirectory( project_a )
add_subdirectory( project_b )

=== examples/find_package/projects/fftw/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.12 FATAL_ERROR)
find_package( ecbuild 3.4 REQUIRED )
project( find_fftw VERSION 0.0.0 LANGUAGES CXX )

# Provide FFTW_ENABLE_MKL=ON  to force MKL implementation
# Provide FFTW_ENABLE_MKL=OFF to force no MKL implementation
# Not providing FFTW_ENABLE_MKL will prefer MKL implementation and fall back to official FFTW

ecbuild_find_package( NAME FFTW REQUIRED COMPONENTS single )

### Try to link executable with FFTW_LIBRARIES

ecbuild_add_test( TARGET  test_fftw 
                  SOURCES test_fftw.cc
                  LIBS    FFTW::fftw3f )

=== examples/find_package/projects/proj4/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.11 FATAL_ERROR)
find_package( ecbuild 3.0.0 REQUIRED )
project( find_proj4  VERSION 0.0.0 LANGUAGES C CXX Fortran )

find_package( PROJ4 6 )

if( NOT TARGET PROJ4::proj )
  ecbuild_error( "PROJ4::proj target undefined" )
endif()

ecbuild_add_test( TARGET main SOURCES example.c LIBS PROJ4::proj )

=== regressions/ECBUILD_511/bundleAB/projectB/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.12 FATAL_ERROR)

find_package(ecbuild 3.4 REQUIRED)

project(projectB VERSION 0.1.0 LANGUAGES C)

find_package(projectA REQUIRED)

ecbuild_add_library(
  TARGET projectB
  SOURCES libraryB.h libraryB.c
  PUBLIC_LIBS projectA
  PUBLIC_INCLUDES $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>
  INSTALL_HEADERS LISTED)

ecbuild_install_project(NAME ${PROJECT_NAME})

=== tests/bundle_override_features/bundle/project_b/CMakeLists.txt ===
cmake_minimum_required( VERSION 3.11 FATAL_ERROR )

find_package( ecbuild REQUIRED )

project( project_b VERSION 0.0.0 LANGUAGES C )

if( NOT HAVE_TESTS )
    ecbuild_error( "Tests should be enabled" )
endif()

# ENABLE_X was already defined and cached in project_a
if( NOT ENABLE_X )
    ecbuild_error( "This test is designed to have ENABLE_X=OFF" )
endif()

if( NOT DEFINED PROJECT_B_ENABLE_X )
    ecbuild_error( "This test is designed to have PROJECT_B_ENABLE_X=OFF" )
endif()

ecbuild_add_option( FEATURE X DEFAULT ON )

if( HAVE_X )
    ecbuild_error( "Feature X should be disabled, as PROJECT_B_ENABLE_X=${PROJECT_B_ENABLE_X},"
                   " even though ENABLE_X=OFF" )
endif()

=== debian/changelog ===
ecbuild (3.8.2-1) unstable; urgency=medium

  * New upstream release

 -- Alastair McKinstry <mckinstry@debian.org>  Wed, 13 Dec 2023 06:48:01 +0000

ecbuild (3.8.1-1) unstable; urgency=medium

  * New upstream release

 -- Alastair McKinstry <mckinstry@debian.org>  Fri, 06 Oct 2023 09:44:23 +0100

=== debian/control ===
--- 
+++ 
@@ -5,7 +5,7 @@
 Build-Depends: debhelper-compat (= 13),
   dh-buildinfo,
   cmake
-Standards-Version: 4.6.1
+Standards-Version: 4.6.2
 Homepage: https://confluence.ecmwf.int/spaces/viewspace.action?key=ecbuild
 Vcs-Browser: https://salsa.debian.org:/science-team/ecbuild.git
 Vcs-Git: https://salsa.debian.org/science-team/ecbuild.git -b debian/latest

## ecbuild 3.8.5

=== tests/CMakeLists.txt ===
add_subdirectory( bundle_subdir )
add_subdirectory( bundle_subproj ) # ECBUILD-460
add_subdirectory( bundle_override_features ) # ECBUILD-486
add_subdirectory( ecbuild_regex_escape )
add_subdirectory( ecbuild_remove_fortran_flags ) # ECBUILD-484
add_subdirectory( ecbuild_find_package )
add_subdirectory( ecbuild_add_option )
add_subdirectory( ecbuild_add_flags )
add_subdirectory( find_ecbuild )
add_subdirectory( project_import )
add_subdirectory( ecbuild_shared_libs )
add_subdirectory( interface_library )

=== debian/changelog ===
ecbuild (3.8.5-1) unstable; urgency=medium

  * New upstream release

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 24 Jun 2024 08:01:06 +0100

ecbuild (3.8.4-2) unstable; urgency=medium

  * Add perl:Depends in d/control
  * Add gfortran depends for tests to run

 -- Alastair McKinstry <mckinstry@debian.org>  Thu, 09 May 2024 09:32:19 +0100

ecbuild (3.8.4-1) unstable; urgency=medium

  * New upstream release
  * Make Debian Science team the maintainer
  * Standards-Version: 4.7.0; no change required

 -- Alastair McKinstry <mckinstry@debian.org>  Thu, 25 Apr 2024 08:31:17 +0100

ecbuild (3.8.3-1) unstable; urgency=medium

  * New upstream release
  * Move g++14.patch from metview to override c++11 standard

 -- Alastair McKinstry <mckinstry@debian.org>  Thu, 11 Apr 2024 10:19:03 +0100

=== debian/control ===
Source: ecbuild
Section: science
Priority: optional
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Alastair McKinstry <mckinstry@debian.org>
Build-Depends: debhelper-compat (= 13),
  dh-buildinfo,
  gfortran  | fortran-compiler,
  cmake
Standards-Version: 4.7.0
Homepage: https://confluence.ecmwf.int/spaces/viewspace.action?key=ecbuild
Vcs-Browser: https://salsa.debian.org/science-team/ecbuild.git
Vcs-Git: https://salsa.debian.org/science-team/ecbuild.git -b debian/latest

Package: ecbuild
Section: libs
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}, ${perl:Depends},
 cmake,
 gfortran  | fortran-compiler,
 chrpath,
 dh-buildinfo
Enhances: debhelper
Provides: dh-sequence-ecbuild
Description: Build system for ECMWF software
 This is a toolkit from ECMWF extend CMAKE with macros used at ECMWF.
 .
 ECMWF is the European Centre for Medium-Range Weather Forecasts.

## ecbuild 3.9.0

=== debian/changelog ===
ecbuild (3.9.0-2) unstable; urgency=medium

  * Drop dh-buildinfo as redundant

 -- Alastair McKinstry <mckinstry@debian.org>  Thu, 28 Nov 2024 09:38:59 +0000

ecbuild (3.9.0-1) unstable; urgency=medium

  * New upstream release

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 19 Nov 2024 05:16:11 +0000

ecbuild (3.8.5-2) unstable; urgency=medium

  * Drop setting DISABLE_OS_CHECK, ENABLE_BIT_REPRODUCIBLE; not used?

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 14 Oct 2024 15:04:41 +0100

## ecbuild 3.9.1

=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -7,6 +7,11 @@
 add_subdirectory( ecbuild_add_option )
 add_subdirectory( ecbuild_add_flags )
 add_subdirectory( find_ecbuild )
-add_subdirectory( project_import )
 add_subdirectory( ecbuild_shared_libs )
 add_subdirectory( interface_library )
+add_subdirectory( project_import )
+add_subdirectory( project_summary )
+add_subdirectory( ecbuild_override_compiler_flags )
+add_subdirectory( test_properties )
+add_subdirectory( test_requires_simple )
+add_subdirectory( test_requires_complex )

=== tests/project_summary/test_project/CMakeLists.txt ===
cmake_minimum_required( VERSION 3.18.4 FATAL_ERROR )
find_package( ecbuild 3.4 REQUIRED )

project( proja LANGUAGES NONE VERSION 0.2 )
ecbuild_add_option(
    FEATURE MYFEATURE
    DEFAULT ON
)

project( projb LANGUAGES NONE VERSION 0.1 )
ecbuild_add_option(
    FEATURE MYFEATURE
    DEFAULT OFF
)

ecbuild_print_summary()

=== tests/test_properties/test_project/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.7 FATAL_ERROR)

find_package( ecbuild REQUIRED )
project( test_test_properties VERSION 0.1.0 LANGUAGES NONE )

ecbuild_add_test(
    TARGET clean_output
    TEST_PROPERTIES FIXTURES_SETUP clean_output
    COMMAND ${CMAKE_COMMAND}
    ARGS -E remove ${CMAKE_CURRENT_BINARY_DIR}/output.txt
)

ecbuild_add_test(
    TARGET write_hello
    TEST_PROPERTIES FIXTURES_SETUP write_hello FIXTURES_REQUIRED clean_output
    COMMAND bash
    ARGS -c "echo -n 'Hello, ' >> ${CMAKE_CURRENT_BINARY_DIR}/output.txt"
)

ecbuild_add_test(
    TARGET write_world_after_hello
    TEST_PROPERTIES FIXTURES_REQUIRED write_hello
    COMMAND bash
    ARGS -c "echo -n 'World!' >> ${CMAKE_CURRENT_BINARY_DIR}/output.txt"
)

=== debian/changelog ===
ecbuild (3.9.1-1) unstable; urgency=medium

  * New upstream release

 -- Alastair McKinstry <mckinstry@debian.org>  Wed, 12 Feb 2025 10:15:33 +0000

=== debian/control ===
--- 
+++ 
@@ -4,7 +4,6 @@
 Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
 Uploaders: Alastair McKinstry <mckinstry@debian.org>
 Build-Depends: debhelper-compat (= 13),
-  dh-buildinfo,
   gfortran  | fortran-compiler,
   cmake
 Standards-Version: 4.7.0
@@ -20,7 +19,6 @@
  cmake,
  gfortran  | fortran-compiler,
  chrpath,
- dh-buildinfo
 Enhances: debhelper
 Provides: dh-sequence-ecbuild
 Description: Build system for ECMWF software

## ecbuild 3.10.0

=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -1,3 +1,4 @@
+add_subdirectory( bundle_options )
 add_subdirectory( bundle_subdir )
 add_subdirectory( bundle_subproj ) # ECBUILD-460
 add_subdirectory( bundle_override_features ) # ECBUILD-486
@@ -5,11 +6,13 @@
 add_subdirectory( ecbuild_remove_fortran_flags ) # ECBUILD-484
 add_subdirectory( ecbuild_find_package )
 add_subdirectory( ecbuild_add_option )
+add_subdirectory( ecbuild_add_option_multiproject_defaults )
 add_subdirectory( ecbuild_add_flags )
 add_subdirectory( find_ecbuild )
 add_subdirectory( ecbuild_shared_libs )
 add_subdirectory( interface_library )
 add_subdirectory( project_import )
+add_subdirectory( project_options )
 add_subdirectory( project_summary )
 add_subdirectory( ecbuild_override_compiler_flags )
 add_subdirectory( test_properties )

=== tools/CMakeLists.txt ===
# (C) Copyright 2011- ECMWF.
#
# This software is licensed under the terms of the Apache Licence Version 2.0
# which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
# In applying this licence, ECMWF does not waive the privileges and immunities
# granted to it by virtue of its status as an intergovernmental organisation
# nor does it submit to any jurisdiction.

list( APPEND ecbuild_bin_files
ecbuild
git-meld
git-mproj
check_install.sh
apply_license.sh
license.pl )

add_custom_target( ecbuild_bin SOURCES ${ecbuild_bin_files} )

install( PROGRAMS ecbuild DESTINATION ${INSTALL_BIN_DIR} )

#	install( PROGRAMS ${ecbuild_bin_files} DESTINATION ${INSTALL_BIN_DIR} )

=== examples/boost-python-lib/CMakeLists.txt ===
# (C) Copyright 2011- ECMWF.
#
# This software is licensed under the terms of the Apache Licence Version 2.0
# which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
# In applying this licence, ECMWF does not waive the privileges and immunities
# granted to it by virtue of its status as an intergovernmental organisation
# nor does it submit to any jurisdiction.

cmake_minimum_required( VERSION 3.11 FATAL_ERROR )

find_package(ecbuild REQUIRED)
project( mypython VERSION 0.10.0 LANGUAGES CXX )

###############################################################################
# find extra packages

# Python
# Can specify non-default distribution with CMake variable PYTHON_EXECUTABLE
ecbuild_find_python()
ecbuild_info("PYTHON_EXECUTABLE    : ${PYTHON_EXECUTABLE}")
ecbuild_info("PYTHON_INCLUDE_DIRS  : ${PYTHON_INCLUDE_DIRS}")
ecbuild_info("PYTHON_LIBRARIES     : ${PYTHON_LIBRARIES}")

# Boost
# Can specify non-default distribution with CMake variable BOOST_ROOT
set( Boost_MINIMUM_VERSION "1.47" )
find_package( Boost ${Boost_MINIMUM_VERSION} REQUIRED
              COMPONENTS python )
ecbuild_info("Boost_LIBRARIES     : ${Boost_LIBRARIES}" )

###############################################################################
# Contents

ecbuild_add_library( TARGET       mypython
                     INCLUDES     ${Boost_INCLUDE_DIR} ${PYTHON_INCLUDE_DIRS}
                     PRIVATE_LIBS ${Boost_LIBRARIES} ${PYTHON_LIBRARIES}
                     SOURCES      pythonlib.hpp pythonlib.cpp )
configure_file( mypython.py       ${CMAKE_BINARY_DIR}/lib COPYONLY )

############################################################################################
# Installation

ecbuild_install_project( NAME python_project )

###############################################################################
# Summary

ecbuild_print_summary()



ecbuild_info( "" )
ecbuild_info( "To test the library:" )
ecbuild_info( "--------------------" )
ecbuild_info( "make" )
ecbuild_info( "cd ${CMAKE_CURRENT_BINARY_DIR}/lib" )
ecbuild_info( "python" )
ecbuild_info( ">>> import libmypython" )
ecbuild_info( ">>> help(libmypython)" )
ecbuild_info( "" )
ecbuild_info( "---------------------------------------------------------" )

=== examples/cpp-bundle/CMakeLists.txt ===
# (C) Copyright 2011- ECMWF.
#
# This software is licensed under the terms of the Apache Licence Version 2.0
# which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
# In applying this licence, ECMWF does not waive the privileges and immunities
# granted to it by virtue of its status as an intergovernmental organisation
# nor does it submit to any jurisdiction.

cmake_minimum_required( VERSION 3.11 FATAL_ERROR )

find_package(ecbuild REQUIRED)
project( cpp_bundle VERSION 0.10.0 LANGUAGES C CXX )

ecbuild_bundle_initialize()

ecbuild_bundle( PROJECT foo )
ecbuild_bundle( PROJECT bar )

ecbuild_bundle_finalize()

=== examples/mix/CMakeLists.txt ===
# (C) Copyright 2011- ECMWF.
#
# This software is licensed under the terms of the Apache Licence Version 2.0
# which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
# In applying this licence, ECMWF does not waive the privileges and immunities
# granted to it by virtue of its status as an intergovernmental organisation
# nor does it submit to any jurisdiction.

cmake_minimum_required( VERSION 3.11 FATAL_ERROR )

find_package( ecbuild REQUIRED )
project( mix VERSION 0.10.0 LANGUAGES CXX Fortran )

### targets

add_subdirectory( fort )

add_subdirectory( cpp )

### pkgconfig exports

ecbuild_pkgconfig( NAME fortbar DESCRIPTION "A fortran library bar" LIBRARIES fortbar )
ecbuild_pkgconfig( NAME fortbaz DESCRIPTION "A fortran library baz" LIBRARIES fortbaz )

### finalize project

ecbuild_install_project( NAME ${PROJECT_NAME} )

ecbuild_print_summary()

=== examples/override-compile-flags/CMakeLists.txt ===
# (C) Copyright 2011- ECMWF.
#
# This software is licensed under the terms of the Apache Licence Version 2.0
# which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
# In applying this licence, ECMWF does not waive the privileges and immunities
# granted to it by virtue of its status as an intergovernmental organisation
# nor does it submit to any jurisdiction.

cmake_minimum_required( VERSION 3.11 FATAL_ERROR )

find_package( ecbuild REQUIRED )

project( override_compile_flags VERSION 0.1 LANGUAGES C Fortran )

ecbuild_bundle_initialize()

ecbuild_bundle( PROJECT bar )
ecbuild_bundle( PROJECT foo )

ecbuild_bundle_finalize()

=== examples/simple/CMakeLists.txt ===
# CMake 3.11 is a minimal requirement for ecBuild. However, we strongly
# recommend using CMake 3.12 or higher
cmake_minimum_required( VERSION 3.11 FATAL_ERROR )

# If you plan on using cmake directly (rather than the `ecbuild` wrapper
# script), make sure that ecBuild can be found, by doing at least one of these:
# * Add ecBuild's `cmake` directory (`share/ecbuild/cmake` when installed) to `CMAKE_MODULE PATH`
# * (CMake 3.12 or higher) Set `ecbuild_ROOT` to the ecBuild install directory
# * Set `ecbuild_DIR` to ecBuild's `lib/cmake/ecbuild` directory
# * Add ecBuild's `cmake` directory to `CMAKE_PREFIX_PATH`
find_package(ecbuild REQUIRED)

# The `project` macro is overridden by ecBuild, which is why
# `find_package(ecbuild)` has to be done before `project()`
project( simple VERSION 0.10.0 LANGUAGES C CXX Fortran )

# Declaring options
# =================
#
# `ecbuild_add_option` is an enhanced version of CMake's `add_option`.
#
# In this case, the `MATRIX` feature can be requested with the `ENABLE_MATRIX`
# CMake variable. Unless `DEFAULT OFF` is specified, the option is on by
# default (provided its `CONDITION` is empty or satisfied).
#
# From your CMake scripts, you can then query the feature using the
# `HAVE_MATRIX` variable.
#
# Any option declared gets automatically advertised when the package is
# installed, enabling the use of e.g. `find_package(simple COMPONENTS MATRIX)`.
# It can also be queried via the `simple_MATRIX_FOUND` variable if the
# component is optional.
#
# The `REQUIRED_PACKAGES` option is a convenience for options that depend on
# certain packages being available. For each package, it expects a string that
# represents a valid argument list for `ecbuild_find_package`. This behaves as
# follows:
# * If `LAPACK` is found, the option will be enabled, unless the
#  `ENABLE_MATRIX` variable is set to `OFF`.
# * If `LAPACK` cannot be found, the behaviour depends on the value of
#   `ENABLE_MATRIX`:
#   * If `ON`, ecBuild will abort with a critical error
#   * If `OFF` or not set, the feature will be disabled
ecbuild_add_option( FEATURE MATRIX
                    DESCRIPTION "Use matrix operations"
                    REQUIRED_PACKAGES "NAME LAPACK" )

# For more complex requirements, the `CONDITION` argument can be any expression
# acceptable in an `if` statement. The same behaviour can also be achieved using
# `CONDITION HAVE_MATRIX` together with `REQUIRED_PACKAGES "NAME GSL"`
find_package(GSL QUIET)
ecbuild_add_option( FEATURE BESSEL
                    DESCRIPTION "Compute Bessel function"
                    CONDITION HAVE_MATRIX AND GSL_FOUND )

# Declaring targets
# =================
#
# ecBuild provides wrappers around CMake's `add_library`, `add_executable`, and
# `add_test`. They take care of the target's creation, as well as making sure
# it gets installed and exported properly. They also provide a concise way of
# adding library dependencies and declaring include directories.
#
# Libraries
# ---------
#
# In `circle/CMakeLists.txt`, the library `circle` is created as a shared
# library (the default), and has only one source file `area.f90`.
#
# ecbuild_add_library(
#     TARGET circle
#     TYPE SHARED
#     SOURCES area.f90
# )
#
# If some header files are present in the list of source files, they can be
# automatically installed by specifying `INSTALL_HEADERS LISTED`. If the
# library has some dependencies, they can be declared with `PUBLIC_LIBS lib1
# [lib2...]` and/or `PRIVATE_LIBS lib1 [lib2...]`, where `PUBLIC` and `PRIVATE`
# have the same meaning as for CMake's `target_link_libraries`. The same
# applies for include directories using the `PUBLIC_INCLUDES` and
# `PRIVATE_INCLUDES` keywords.
#
# Tests
# -----
#
# A test can be defined in the same way. Since the distinction between public
# and private dependencies has less importance for tests and executable, they
# can be provided using the `LIBS` and `INCLUDES` keywords.
#
# ecbuild_add_test(
#     TARGET  test_area
#     SOURCES test_area.c
#     LIBS    circle
# )
#
# Some tests may need to run a script rather than an executable target. This
# can be done as well, replacing the `TARGET` keyword by `COMMAND` (and removing
# `SOURCES` and `LIBS`), pointing to a script file to be run. Additional
# arguments can be provided with the `ARGS` keyword, and environment variables
# using the `ENVIRONMENT` keyword.
#
# Since tests may depend on some features being enabled, the `CONDITION`
# keyword can be used, just like in `ecbuild_add_option`.
#
# Executables
# -----------
#
# The same semantics apply for executables. In `compute/CMakeLists.txt`, the
# `compute` executable is made from the source file `compute.cc` with
# additional preprocessor definitions fetched from `${compute_defs}`, and with
# a dependency on the `circle` library.
#
# ecbuild_add_executable(
#
#     TARGET
#         compute
#
#     SOURCES
#         compute.cc
#
#     DEFINITIONS
#         "${compute_defs}"
#
#     LIBS
#         circle
# )

add_subdirectory( circle )

add_subdirectory( compute )

# Generating pkg-config files
# ===========================
#
# A pkg-config file will be created for the `circle` library. It will be
# installed in `lib/pkgconfig/circle.pc`.
ecbuild_pkgconfig(
    NAME circle
    DESCRIPTION "Functions on circles"
    LIBRARIES circle )

# Epilogue
# ========
#
# This will ensure everything gets installed in a unified way, provide
# appropriate install locations, and generate a `<project>-config.cmake`
# allowing the package to be imported from other CMake projects.
ecbuild_install_project( NAME ${PROJECT_NAME} )

# This will print a summary of the build environment and options to the screen
# when configuration is done.
ecbuild_print_summary()

=== regressions/ECBUILD_359/CMakeLists.txt ===

configure_file(run-test.sh.in run-test.sh @ONLY)
configure_file(test-CMakeLists.txt CMakeLists.txt COPYONLY)

ecbuild_add_test(
  TARGET     ECBUILD-359
  TYPE       SCRIPT
  COMMAND    run-test.sh
)

=== tests/bundle_options/CMakeLists.txt ===

ecbuild_add_test(
  TARGET     test_ecbuild_bundle_options
  TYPE       SCRIPT
  COMMAND    ${CMAKE_CURRENT_SOURCE_DIR}/configure.sh
  ENVIRONMENT CMAKE_CURRENT_SOURCE_DIR=${CMAKE_CURRENT_SOURCE_DIR} CMAKE_CURRENT_BINARY_DIR=${CMAKE_CURRENT_BINARY_DIR}
)

=== tests/ecbuild_add_flags/CMakeLists.txt ===
set(_dir ${CMAKE_CURRENT_BINARY_DIR})
configure_file(run-test.sh.in ${_dir}/run-test.sh @ONLY)
configure_file(test_ecbuild_add_flags.cmake ${_dir}/CMakeLists.txt COPYONLY)

ecbuild_add_test(
  TARGET     test_ecbuild_add_flags
  TYPE       SCRIPT
  COMMAND    run-test.sh
)

=== tests/ecbuild_find_package/CMakeLists.txt ===

ecbuild_add_test(
  TARGET     test_ecbuild_find_package
  TYPE       SCRIPT
  COMMAND    ${CMAKE_CURRENT_SOURCE_DIR}/build-and-run.sh
  ENVIRONMENT CMAKE_CURRENT_SOURCE_DIR=${CMAKE_CURRENT_SOURCE_DIR} CMAKE_CURRENT_BINARY_DIR=${CMAKE_CURRENT_BINARY_DIR}
)

=== examples/config-bundle/subproj1/CMakeLists.txt ===
# (C) Copyright 2011- ECMWF.
#
# This software is licensed under the terms of the Apache Licence Version 2.0
# which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
# In applying this licence, ECMWF does not waive the privileges and immunities
# granted to it by virtue of its status as an intergovernmental organisation
# nor does it submit to any jurisdiction.

cmake_minimum_required( VERSION 3.11 FATAL_ERROR )

find_package(ecbuild REQUIRED)
project( subproj_1 VERSION 0.1 LANGUAGES C )

ecbuild_debug_var( CMAKE_C_FLAGS )
ecbuild_debug_var( CMAKE_C_FLAGS_DEBUG )

=== debian/changelog ===
ecbuild (3.10.0-1) unstable; urgency=medium

  * New upstream release
  * d//copyright: fix ordering for correct machine-readability
  * Standards-Version: 4.7.2

 -- Alastair McKinstry <mckinstry@debian.org>  Sun, 13 Apr 2025 09:00:09 +0100

=== debian/control ===
--- 
+++ 
@@ -6,7 +6,7 @@
 Build-Depends: debhelper-compat (= 13),
   gfortran  | fortran-compiler,
   cmake
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Homepage: https://confluence.ecmwf.int/spaces/viewspace.action?key=ecbuild
 Vcs-Browser: https://salsa.debian.org/science-team/ecbuild.git
 Vcs-Git: https://salsa.debian.org/science-team/ecbuild.git -b debian/latest

## ecbuild 3.11.0

=== bin/CMakeLists.txt ===
install( PROGRAMS ecbuild DESTINATION ${INSTALL_BIN_DIR} )

=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -4,15 +4,18 @@
 add_subdirectory( bundle_override_features ) # ECBUILD-486
 add_subdirectory( ecbuild_regex_escape )
 add_subdirectory( ecbuild_remove_fortran_flags ) # ECBUILD-484
-add_subdirectory( ecbuild_find_package )
 add_subdirectory( ecbuild_add_option )
 add_subdirectory( ecbuild_add_option_multiproject_defaults )
 add_subdirectory( ecbuild_add_flags )
+add_subdirectory( ecbuild_find_package )
+add_subdirectory( ecbuild_find_python )
 add_subdirectory( find_ecbuild )
 add_subdirectory( ecbuild_shared_libs )
 add_subdirectory( interface_library )
 add_subdirectory( project_import )
 add_subdirectory( project_options )
+add_subdirectory( project_options_cached )
+add_subdirectory( project_options_cached_multiproject )
 add_subdirectory( project_summary )
 add_subdirectory( ecbuild_override_compiler_flags )
 add_subdirectory( test_properties )

=== tests/interface_library/CMakeLists.txt ===

ecbuild_add_test(
  TARGET     test_ecbuild_interface_library
  TYPE       SCRIPT
  COMMAND    ${CMAKE_CURRENT_SOURCE_DIR}/build-and-run.sh
  ENVIRONMENT CMAKE_CURRENT_SOURCE_DIR=${CMAKE_CURRENT_SOURCE_DIR} CMAKE_CURRENT_BINARY_DIR=${CMAKE_CURRENT_BINARY_DIR}
)

=== examples/cpp-bundle-nested/baz/CMakeLists.txt ===
cmake_minimum_required( VERSION 3.18 FATAL_ERROR )

find_package( ecbuild REQUIRED )
project( baz VERSION 1.0.0 LANGUAGES C CXX )

### targets

ecbuild_find_package( NAME foo REQUIRED )

ecbuild_add_library( TARGET            baz
                     SOURCES           baz.h baz.c
                     PUBLIC_LIBS       foo
                     PUBLIC_INCLUDES
                        $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}> )

ecbuild_add_executable(
    TARGET     master_baz
    SOURCES    main.cc
    LIBS       baz
)

ecbuild_add_test(
    TARGET     test_baz
    SOURCES    test.cc
    LIBS       baz
)

ecbuild_install_project( NAME ${PROJECT_NAME} )

ecbuild_print_summary()

=== tests/ecbuild_find_python/interpreter_only_project/CMakeLists.txt ===
cmake_minimum_required( VERSION 3.18 FATAL_ERROR )
find_package( ecbuild 3.4 REQUIRED )

project( project LANGUAGES NONE VERSION 0.2 )

ecbuild_find_python( NO_LIBS )

include(${CMAKE_SOURCE_DIR}/../cmake/expecting.cmake)

expecting_true( CONDITION PYTHON_FOUND )
expecting_true( CONDITION PYTHONINTERP_FOUND )
expecting_false( CONDITION PYTHONLIBS_FOUND )
expecting_nonempty( CONDITION PYTHON_EXECUTABLE)
expecting_nonempty( CONDITION PYTHON_VERSION_MAJOR )
expecting_nonempty( CONDITION PYTHON_VERSION_MINOR )
expecting_nonempty( CONDITION PYTHON_VERSION_PATCH )
expecting_nonempty( CONDITION PYTHON_VERSION_STRING )
expecting_empty( CONDITION PYTHON_INCLUDE_DIRS )
expecting_empty( CONDITION PYTHON_LIBRARIES )
expecting_nonempty( CONDITION PYTHON_SITE_PACKAGES )

expecting_true( CONDITION Python_FOUND )
expecting_true( CONDITION Python_Interpreter_FOUND )
expecting_false( CONDITION Python_Development_FOUND )
expecting_nonempty( CONDITION Python_EXECUTABLE )
expecting_nonempty( CONDITION Python_VERSION_MAJOR )
expecting_nonempty( CONDITION Python_VERSION_MINOR )
expecting_nonempty( CONDITION Python_VERSION_PATCH )
expecting_nonempty( CONDITION Python_VERSION )
expecting_empty( CONDITION Python_INCLUDE_DIRS )
expecting_empty( CONDITION Python_LIBRARIES )
expecting_nonempty( CONDITION Python_SITELIB )

=== tests/ecbuild_add_option_multiproject_defaults/test_project/projc/CMakeLists.txt ===

find_package( ecbuild 3.4 REQUIRED )

project( projc LANGUAGES NONE VERSION 0.3 )
ecbuild_add_option(
    FEATURE FEATURE_A
    DEFAULT ON
    REQUIRED_PACKAGES nonexistent       
)

=== debian/changelog ===
ecbuild (3.11.0-1) unstable; urgency=medium

  * New upstream release

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 30 Jun 2025 10:21:46 +0100

=== debian/watch ===
version=3
opts=filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/ecbuild-$1\.tar\.gz/ \
  https://github.com/ecmwf/ecbuild/tags .*/v?(\d\d?\d?\..+).tar\.gz
